
public class ScopeTester {
	// The scope of the class level variable is the entire class
	// Any method that is part of the class can access it.
	int classLevelVariable;
	// We've seen static class level variables before: Math.E, Integer.MIN_VALUE
	// There is just one common copy of the static variable and can be accessed
	// using the class name or an object of the class. 
	// Usually meant for constant data but not always.
	//
	// (PART 2) Remove the comment below: 
	// static String scifiPhrase;
	
	// (PART 3) Remove the comment below:
	//  static int counter;
	
	ScopeTester() {
		// The scope of the method level variable is this method.
		int methodLevelVariable = 7;
		classLevelVariable = methodLevelVariable;		
        System.out.println(" ScopeTester Constructor with class variable: " + classLevelVariable);
	    // (PART 2) Remove the comment below: 
	    // scifiPhrase = "Klaatu barada nikto";
		
		// (PART 3) Remove the comment below:
		//  counter = 0;
	}
	
    public static void main(String[] args) {

        System.out.println("\nSet a breakpoint at the start of ScopeTester's constructor and run/view the debugger\n");  
        System.out.println("\nStep through the constructor and notice when variables are visible\n");  
        ScopeTester s = new ScopeTester();      		
	    // (PART 2) Remove the comments below: 
	    // s.scifiPhrase = "E.T. Phone Home";
		// System.out.println("\nScifiPhrase with object specifier is: " + s.scifiPhrase + "\n");
        // ScopeTester.scifiPhrase = "KAAAAHN";		
		// System.out.println("\nSecond time, scifiPhrase with object specifier is: " + s.scifiPhrase + "\n");
		// System.out.println("\nSecond time, scifiPhrase with class specifier is: " + ScopeTester.scifiPhrase + "\n");
		
		// (PART 3) Remove the comments below:
		//  s.counter++;
		//  ScopeTester part3 = new ScopeTester();
		//  part3.counter += 3;
		//  ScopeTester.counter++;
		//  System.out.println("\n counter is: " + ScopeTester.counter + "\n");
    }

}